#include <vcl.h>
#include <fstream>
#include <iostream.h>
#pragma hdrstop

#include "math.h"

#include "Calib.h"

#pragma package(smart_init)
#pragma link "FloatEdit"
#pragma resource "*.dfm"

TCalibForm *CalibForm;

//---------------------------------------------------------------------------

__fastcall TCalibForm::TCalibForm(TComponent* Owner)
  :	TForm(Owner)
{ }

//-------------------------   ----------------------------------

void __fastcall TCalibForm::FormCreate(TObject *Sender)
{
  FModified = 0;
  //Off(); // 
  TreeView->Selected = TreeView->Items->Item[3]; // TreeViewChange
  TreeView->Items->Item[3]->Expand(0);
}

//------------------------     ---------------------------

void __fastcall TCalibForm::FormCloseQuery(TObject *Sender, bool &CanClose)
{
  if(FModified)
    switch(Application->MessageBox("  ?",
           " ", MB_YESNOCANCEL | MB_ICONQUESTION))
    {
      case IDYES : { FModified = 0; /*SaveCalib*/ break; }
      case IDNO  : { FModified = 0; /*ReadCalib*/ break; }
      default    : CanClose = 0;
    }
  //if(ModalResult == mrCancel)
    //ReadCalib;
}

//--------------------------   ---------------------------------

void __fastcall TCalibForm::FormClose(TObject *Sender, TCloseAction &Action)
{
  //Off(); // 
  Action    = caFree;
  CalibForm = NULL;
}

//---------------------------------------------------------------------------
//-------------------    -----------------------
//---------------------------------------------------------------------------

//------------------------  "" -------------------------------

void __fastcall TCalibForm::BackActionExecute(TObject *Sender)
{
  if((FStep == -1) || (FStep == 2))
  {
    TTabSheet* tab = GetTabByImgIndex(FPoint);
    if(tab != NULL) PageControl->ActivePage = tab;
    FStep = 0; DoCalib(FPoint, FStep);
  }
  else
  {
    int i = TreeView->Selected->AbsoluteIndex - 1;
    if(i >= 0)
    TreeView->Selected = TreeView->Items->Item[i];
  }
}

//-------------------------  "" ---------------------------------

void __fastcall TCalibForm::NextActionExecute(TObject *Sender)
{
//  if(FStep < 0)
  {
    int i = TreeView->Selected->AbsoluteIndex + 1;
    if(i < TreeView->Items->Count)
      TreeView->Selected = TreeView->Items->Item[i];
  }
//  else
//   DoCalib(FPoint, FStep);
}

//------------------------  "" ------------------------------

void __fastcall TCalibForm::SkipActionExecute(TObject *Sender)
{
  int i = TreeView->Selected->AbsoluteIndex + 1;
  if(TreeView->Selected->HasChildren && TreeView->Selected->ImageIndex != 30)
    i = i + 2;
  if(i < TreeView->Items->Count)
    TreeView->Selected = TreeView->Items->Item[i];
}

//--------------------------  Edit ---------------------------------

//On Changed:

void __fastcall TCalibForm::edValChanged(TObject *Sender)
{
  if(FStep == 1) E1 = edVal->Value; else E2 = edVal->Value;
}

//On Enter Press:

void __fastcall TCalibForm::edValEnterPress(TObject *Sender)
{
  if(FStep < 0)
  {
    int i = TreeView->Selected->AbsoluteIndex + 1;
    if(i < TreeView->Items->Count)
      TreeView->Selected = TreeView->Items->Item[i];
  }
  else DoCalib(FPoint, FStep);
}

//--------        TreeList -----------

void __fastcall TCalibForm::TreeViewChange(TObject *Sender, TTreeNode *Node)
{
/*
  TTabSheet* tab = GetTabByImgIndex(Node->ImageIndex); // 
  if(tab != NULL)
  {
    PageControl->ActivePage = tab;
    labTitle->Caption = PageControl->ActivePage->Caption;
    FPoint = Node->ImageIndex; FStep = 0;
    DoCalib(FPoint, FStep);
  }
*/
}

//--------------   Enter  TreeList -------------------------

void __fastcall TCalibForm::TreeViewKeyDown(TObject *Sender, WORD &Key,
	  TShiftState Shift)
{
  if(Key == VK_RETURN)
  {
    int i = TreeView->Selected->AbsoluteIndex + 1;
    if(i < TreeView->Items->Count)
      TreeView->Selected = TreeView->Items->Item[i];
  }
}

//--------------     TreeList --------------------------

void __fastcall TCalibForm::TreeViewDblClick(TObject *Sender)
{
  TTreeNode *Node;
  Node = TreeView->Selected;
  if(Node) TreeViewChange(TreeView, Node);
}

//--------------------   : ----------------------

void __fastcall TCalibForm::TreeViewCollapsing(TObject *Sender,
      TTreeNode *Node, bool &AllowCollapse)
{
  if(Node->AbsoluteIndex == 0) AllowCollapse = 0;
}

//----------------   TabSHeet   ---------------------

void __fastcall TCalibForm::MessPage(int n)
{
  TTabSheet* tab = GetTabByImgIndex(n); //  n
  if(tab != NULL)
  {
    PageControl->ActivePage = tab;
    if(n == mpError) MessageBeep(MB_ICONEXCLAMATION);
  }
  if(n == mpOk) FModified = 1;
  //Caption = TITLETEXT + ExtractFileName(Equip->CalibName) +
  //                                            (FModified? " - ":"");
}

//---------      ImageIndex ------------

//    ,  NULL

TTabSheet* __fastcall TCalibForm::GetTabByImgIndex(int ImageIndex)
{
  for(int i = 0; i < PageControl->PageCount; i++)
  {
    TTabSheet* page = PageControl->Pages[i];
    if (page->ImageIndex == ImageIndex)
    return(page);
  }
  return NULL;
}

//-------       : --------

bool __fastcall TCalibForm::IsYNew(double Y1, double Y2, double Z1, double Z2)
{
  //if(Equip->DevType == NONE) return(0);
  //return(!((fabs(Y1 - Z1) < PRECISION) && (fabs(Y2 - Z2) < PRECISION)));
  return(0);
}

//---------------------------------------------------------------------------
//----------------      --------------------
//---------------------------------------------------------------------------

void __fastcall TCalibForm::DoCalib(int p, int &s)
{
  ControlsDE(p, s); /// Controls
  switch (p)
  {
  // :
  case 0:   DoCalNoEx(s);    break;
  case 10:  DoCalLoad(s);    break; //
  case 20:  DoCalSave(s);    break; //
  case 30:  DoCalNoEx(s);    break; //
  //Voltage DAC:
  case 40:  DoCalNoEx(s);    break;
  case 41:  DoCalDacV(s, 0); break; //point 1
  case 42:  DoCalDacV(s, 1); break; //point 2
  //Current DAC:
  case 50:  DoCalNoEx(s);    break;
  case 51:  DoCalDacV(s, 0); break; //point 1
  case 52:  DoCalDacV(s, 1); break; //point 2
  //Voltage ADC:
  case 60:  DoCalNoEx(s);    break;
  case 61:  DoCalDacV(s, 0); break; //point 1
  case 62:  DoCalDacV(s, 1); break; //point 2
  //Current ADC:
  case 70:  DoCalNoEx(s);    break;
  case 71:  DoCalDacV(s, 0); break; //point 1
  case 72:  DoCalDacV(s, 1); break; //point 2
  }
}

//------------------- / Controls ------------------------

void __fastcall TCalibForm::ControlsDE(int p, int s)
{
  btnBack->Enabled = p > 0;
  btnSkip->Enabled = (p < MAX_INDEX);
  btnNext->Enabled = (p < MAX_INDEX) || (s < 1);
  if(s == 0)
  {
    EdBox->Visible = 0;
    edVal->ReadOnly = 0;
    edVal->ValueVisible = 1;
  }
}

//---------------------------------------------------------------------------
//----------------     ---------------------
//---------------------------------------------------------------------------

void __fastcall TCalibForm::DoCalNoEx(int &s)
{
  //Equip->Off(); //  
  if(s == 0) s = -2;
}

//---------------------------------------------------------------------------
//--------------   " " --------------------
//---------------------------------------------------------------------------

void __fastcall TCalibForm::DoCalLoad(int &s)
{
  if(s == 0)
  {
    s = -2;
    //edLoadFileName->Text = Equip->CalibName;
    edLoadFileName->SelStart = edLoadFileName->Text.Length();
  }
}

//-----------------    "Open": ------------------------

void __fastcall TCalibForm::btnLoadBrowseClick(TObject *Sender)
{
  //OpenDialog->InitialDir = ExtractFilePath(ParamStr(0)) + CALIB_DIR;
  OpenDialog->FileName = ExtractFileName(edLoadFileName->Text);
  OpenDialog->Filter =
    "  (*.cal)|*.cal|  -2 (*.kfc)|*.kfc";
  OpenDialog->DefaultExt = "cal";
  if(OpenDialog->Execute())
  {
    edLoadFileName->Text = OpenDialog->FileName;
    edLoadFileName->SelStart = edLoadFileName->Text.Length();
    if(ExtractFileExt(OpenDialog->FileName) == ".kfc")
      ConvertKfc(edLoadFileName->Text);
        //else Equip->ReadCalibF(edLoadFileName->Text);
    FModified = 0;
    //Caption = TITLETEXT + ExtractFileName(Equip->CalibName);
  }
}

//-------------------  KFC  CAL: -----------------------------

void __fastcall TCalibForm::ConvertKfc(const AnsiString FileName)
{
//
}

//--------------------   ENTER: -----------------------------

void __fastcall TCalibForm::edLoadFileNameKeyDown(TObject *Sender,
      WORD &Key, TShiftState Shift)
{
  if(Key == VK_RETURN) btnLoadBrowse->OnClick(NULL);
}

//------------------   : ----------------------

void __fastcall TCalibForm::cb71Click(TObject *Sender)
{
  EdBox->Visible = !dynamic_cast<TCheckBox *>(Sender)->Checked;
}

//---------------------------------------------------------------------------
//---------------   " " -----------------
//---------------------------------------------------------------------------

void __fastcall TCalibForm::DoCalSave(int &s)
{
  if(s == 0)
  {
    s = -2;
    //edSaveFileName->Text = Equip->CalibName;
    edSaveFileName->SelStart = edSaveFileName->Text.Length();
  }
}

//------------------    "Save": -----------------------

void __fastcall TCalibForm::btnSaveBrowseClick(TObject *Sender)
{
  //SaveDialog->InitialDir = ExtractFilePath(ParamStr(0)) + CALIB_DIR;
  SaveDialog->FileName = ExtractFileName(edSaveFileName->Text);
  SaveDialog->Filter = "  (*.cal)|*.cal";
  SaveDialog->DefaultExt = "cal";
  if(SaveDialog->Execute())
  {
    edSaveFileName->Text = SaveDialog->FileName;
    edSaveFileName->SelStart = edSaveFileName->Text.Length();
    //Equip->SaveCalibF(edSaveFileName->Text);
    FModified = 0; //Caption = TITLETEXT + ExtractFileName(Equip->CalibName);
  }
}

//----------------------   ENTER: ---------------------------

void __fastcall TCalibForm::edSaveFileNameKeyDown(TObject *Sender,
      WORD &Key, TShiftState Shift)
{
  if(Key == VK_RETURN) btnSaveBrowse->OnClick(NULL);
}

//---------------------------------------------------------------------------
//----------------------   "DAC V" --------------------------
//---------------------------------------------------------------------------

void __fastcall TCalibForm::DoCalDacV(int &s, int range)
{
  k = 1000.0;                           //   
  lbUnit->Caption = "V";                //  - 
  // 1:
  if(range == 0)
  {
    s++;
    lbStep->Caption = "Point 1:";
    EdBox->Visible = 1;                 //  
    edVal->ValueVisible = 0; Repaint(); // 
    Screen->Cursor = crHourGlass;
    { Screen->Cursor = crDefault; }
    E1 = R1 = 0; //Dcv->Value * k;    //   1
    edVal->Value = E1;                  //  
    edVal->ValueVisible = 1;            //  
    edVal->SetFocus();
    return;
  }
  // 2:
  if(range == 1)
  {
    s++;
    lbStep->Caption = "Point 2:";
    EdBox->Visible = 1;                 //  
    EdBox->SetFocus();
    edVal->ValueVisible = 0; Repaint(); // 
    Screen->Cursor = crHourGlass;
    { Screen->Cursor = crDefault; }
    C1 = 0; //Dcv->Code;              //    1
    E2 = R2 = 0; //Dcv->Value * k;    //   2
    edVal->Value = E2;                  //  
    edVal->ValueVisible = 1;            //  
    edVal->SetFocus();
    return;
  }
  //  :
  if(s == 2)
  {
    s = -1;
    EdBox->Visible = 0;                 //  
    if(btnNext->Enabled) btnNext->SetFocus();
    //Screen->Cursor = crHourGlass;
    //try { DcvStart();            //   2
    //} __finally { Screen->Cursor = crDefault; }
    C2 = 0; //Dcv->Code;              //    2
    if(!IsYNew(E1, E2, R1, R2))         //  
    {
      MessPage(mpInfo);                 //    - 
    }
    else
    {
      //if(Dcv->Points2Coeff(E1 / k, E2 / k, C1, C2))
        MessPage(mpOk);                 //   
          //else MessPage(mpError);       //  
    }
    //Off();                       // 
    return;
  }
}

//---------------------------------------------------------------------------


