#ifndef WakePortH
#define WakePortH

#include "WakeCom.h"

#define BAUD   19200 // 
#define NAME "PSL-"

//  :

#define CMD_SET_VI 6 //   

  //TX: word V, word I, byte S
  //RX: byte Err

  //V = 0..VMAX - , x0.01 
  //I = 0..IMAX - , x0.001 
  //S = 0 -  , 1 -  
  //Err = ERR_NO

#define CMD_GET_VI 7 //    

  //TX:
  //RX: byte Err, word V, word I

  //V = 0..VMAX - , x0.01 
  //I = 0..IMAX - , x0.001 
  //Err = ERR_NO

#define CMD_GET_STAT 8 //  

  //TX:
  //RX: byte Err, byte S

  //S.0 = 1 -  
  //S.1 = 1 - CV
  //S.2 = 1 - CC
  //S.3 = 1 - OVP
  //S.4 = 1 - OCP
  //S.5 = 1 - OPP
  //S.6 = 1 - OTP
  //Err = ERR_NO

#define CMD_GET_VI_AVG 9 //     

  //TX:
  //RX: byte Err, word VA, word IA

  //VA = 0..VMAX - , x0.01 
  //IA = 0..IMAX - , x0.001 
  //Err = ERR_NO

#define CMD_GET_VI_FAST 10 //     

  //TX:
  //RX: byte Err, word VF, word IF

  //VF = 0..VMAX - , x0.01 
  //IF = 0..IMAX - , x0.001 
  //Err = ERR_NO

#define CMD_SET_VIP_MAX 11 // . ,   

  //TX: word VM, word IM, word PM
  //RX: byte Err

  //VM = 1000..9999 - , x0.01 
  //IM = 1000..9999 - , x0.001 
  //PM = 10..9999 - , x0.1 
  //Err = ERR_NO

#define CMD_GET_VIP_MAX 12 // . ,   

  //TX:
  //RX: byte Err, word VM, word IM, word PM

  //VM = 1000..9999 - , x0.01 
  //IM = 1000..9999 - , x0.001 
  //PM = 10..9999 - , x0.1 
  //Err = ERR_NO

#define CMD_SET_PRE 13 // 

  //TX: byte N, word V, word I
  //RX: byte Err

  //N = 0..9 -  
  //V = 0..VMAX - , x0.01 
  //I = 0..IMAX - , x0.001 
  //Err = ERR_NO, ERR_PA

#define CMD_GET_PRE 14 // 

  //TX: byte N
  //RX: byte Err, word V, word I

  //N = 0..9 -  
  //V = 0..VMAX - , x0.01 
  //I = 0..IMAX - , x0.001 
  //Err = ERR_NO, ERR_PA

#define CMD_SET_PAR 15 // 

  //TX: byte N, word P
  //RX: byte Err

  //N -   (.  )
  //P -   (.  )
  //Err = ERR_NO, ERR_PA

#define CMD_GET_PAR 16 // 

  //TX: byte N
  //RX: byte Err, word P

  //N -   (.  )
  //P -   (.  )
  //Err = ERR_NO, ERR_PA

#define CMD_GET_FAN 17 //    

  //TX:
  //RX: byte Err, byte S, word T

  //S = 0..100 -  , %
  //T = 0..999 - , x0.1C
  //Err = ERR_NO

#define CMD_SET_DAC 18 //  

  //TX: word DACV, word DACI
  //RX: byte Err

  //DACV = 0..65520 -   
  //DACI = 0..65520 -   
  //Err = ERR_NO

#define CMD_GET_ADC 19 //  

  //TX:
  //RX: byte Err, word ADCV, word ADCI

  //ADCV = 0..65520 -   
  //ADCI = 0..65520 -   
  //Err = ERR_NO

#define CMD_SET_CAL 20 //  

  //TX: byte N, word K
  //RX: byte Err

  //N -   (.  )
  //K -   (.  )
  //Err = ERR_NO, ERR_PA

#define CMD_GET_CAL 21 //  

  //TX: byte N
  //RX: byte Err, word K

  //N -   (.  )
  //K -   (.  )
  //Err = ERR_NO, ERR_PA

//------------------    WAKE: ---------------------

class TWakePort : public TWakeCom
{
private:

protected:

public:
  __fastcall TWakePort();  //
  __fastcall ~TWakePort(); //
  void __fastcall SetVI(int v, int i, bool on);
  void __fastcall GetVI(int &v, int &i);
  void __fastcall GetStat(int &s);
  void __fastcall GetVIavg(int &v, int &i);
  void __fastcall GetVIfast(int &v, int &i);
  void __fastcall SetVIPmax(int v, int i, int p);
  void __fastcall GetVIPmax(int &v, int &i, int &p);
  void __fastcall SetPre(int p, int v, int i);
  void __fastcall GetPre(int p, int &v, int &i);
  void __fastcall SetPar(int p, int v);
  void __fastcall GetPar(int p, int &v);
  void __fastcall GetFan(int &s, int &t);
  void __fastcall SetDAC(int cv, int ci);
  void __fastcall GetADC(int &cv, int &ci);
  void __fastcall SetCal(int c, int v);
  void __fastcall GetCal(int c, int &v);
};

//---------------------------------------------------------------------------

#endif
